#!/usr/bin/perl
#
# WLAN AP cgi
#
# This code is distributed under the terms of the GPL
#
# $Id: wlanap.cgi 533 2014-04-09 09:19:29Z weizen_42 $
#

# Add entry in menu
# MENUENTRY network 090 "WLAN" "WLAN"

use strict;

# enable only the following on debugging purpose
use warnings;
use CGI::Carp 'fatalsToBrowser';

use IO::Socket;
use LWP::UserAgent;

require '/usr/lib/ipcop/general-functions.pl';
require '/usr/lib/ipcop/lang.pl';
require '/usr/lib/ipcop/header.pl';

my $version = 'v3.4.1';
my $addonname = 'wlanap';
my $onlineversion = '';
my $onlinelink = '';
my $timestamplastcheck = '/var/ipcop/addons/wlanap/lastcheck';
my $flagdonotcheck = '/var/ipcop/addons/wlanap/noversioncheck';
my $i = 0;
my $errormessage = '';
my $blue_message = '';
my $status_running = "<td align='center' class='ipcop_running'>$Lang::tr{'running'}</td>";
my $status_stopped = "<td align='center' class='ipcop_stopped'>$Lang::tr{'stopped'}</td>";

my %selected=();
my %checked=();
my $channel = '';
my $txpower = '';

my %wlanapsettings=();
$wlanapsettings{'APMODE'} = 'off';
$wlanapsettings{'BOOTSTART'} = 'off';
$wlanapsettings{'SSID'} = 'IpcopAccesspoint';
$wlanapsettings{'HIDESSID'} = 'off';
$wlanapsettings{'ENC'} = 'wep+wpa';                 # none / wep / wpa / wep+wpa
$wlanapsettings{'ANTENNA'} = 'both';
$wlanapsettings{'TXPOWER'} = 'auto';
# $wlanapsettings{'CC'} = '276';                    # CountryCode, 276 = Germany
$wlanapsettings{'CHAN'} = '1';
$wlanapsettings{'80211N'} = 'off';

$wlanapsettings{'WEPKEY1'} = 'BF715772DADA8A3E7AFFA5C26B';
$wlanapsettings{'WEPKEY2'} = '';
$wlanapsettings{'WEPKEY3'} = '';
$wlanapsettings{'WEPKEY4'} = '';
$wlanapsettings{'USEDKEY'} = '1';

$wlanapsettings{'PWD'} = 'wirelessipcop';
$wlanapsettings{'PSK'} = '69eb868ed7b3cc36d767b729048c9c585234723d1eafbe66e5a16957b7c85e9c';
$wlanapsettings{'WPA'} = '3';
$wlanapsettings{'WPAALGO'}  = 'TKIP';
$wlanapsettings{'WPAREKEY'} = '600';
$wlanapsettings{'WPA2ALGO'} = 'CCMP';

$wlanapsettings{'SYSLOGLEVEL'} = '0';
$wlanapsettings{'DEBUG'} = '4';
$wlanapsettings{'DRIVER'} = 'unknown';              # UNKNOWN / MADWIFI / RT2500 / PRISM54 / ...

# WLANMODE= (a/b/g)
&General::readhash("/var/ipcop/addons/wlanap/settings", \%wlanapsettings);

my %netsettings=();
&General::readhash("/var/ipcop/ethernet/settings", \%netsettings);

my %cgiparams=();
$cgiparams{'ACTION'} = '';
$cgiparams{'RUNNING'} = 'off';
$cgiparams{'APMODE'} = 'off';
$cgiparams{'BOOTSTART'} = 'off';
$cgiparams{'SSID'} = 'IpcopAccesspoint';
$cgiparams{'HIDESSID'} = 'off';
$cgiparams{'ENC'} = 'wep+wpa';               # none / wep / wpa / wep+wpa
$cgiparams{'ANTENNA'} = 'both';
$cgiparams{'TXPOWER'} = 'auto';
$cgiparams{'CHAN'} = '1';
$cgiparams{'80211N'} = 'off';

$cgiparams{'WEPKEY1'} = 'BF715772DADA8A3E7AFFA5C26B';
$cgiparams{'WEPKEY2'} = '';
$cgiparams{'WEPKEY3'} = '';
$cgiparams{'WEPKEY4'} = '';
$cgiparams{'USEDKEY'} = '1';
$cgiparams{'WEPPWD'} = '';
$cgiparams{'WEPKEYCALC'} = '';

$cgiparams{'PWD'} = 'wirelessipcop';
$cgiparams{'PSK'} = '69eb868ed7b3cc36d767b729048c9c585234723d1eafbe66e5a16957b7c85e9c';
$cgiparams{'WPA'} = '3';
$cgiparams{'WPAALGO'}  = 'CCMP TKIP';
$cgiparams{'WPA2ALGO'} = 'CCMP TKIP';
$cgiparams{'WPAREKEY'} = '600';

$cgiparams{'SYSLOGLEVEL'} = '0';
$cgiparams{'DEBUG'} = '4';
&General::getcgihash(\%cgiparams);


&Header::showhttpheaders();

if ( $cgiparams{'ACTION'} eq "$Lang::tr{'save'}" ) 
{
  $wlanapsettings{'APMODE'}     = $cgiparams{'APMODE'};
  $wlanapsettings{'BOOTSTART'}  = $cgiparams{'BOOTSTART'};
  $wlanapsettings{'SSID'}       = $cgiparams{'SSID'};
  $wlanapsettings{'HIDESSID'}   = $cgiparams{'HIDESSID'};
  $wlanapsettings{'ENC'}        = $cgiparams{'ENC'};
  $wlanapsettings{'ANTENNA'}    = $cgiparams{'ANTENNA'};
  $wlanapsettings{'CHAN'}       = $cgiparams{'CHAN'};
  $wlanapsettings{'TXPOWER'}    = $cgiparams{'TXPOWER'};
  $wlanapsettings{'80211N'}     = $cgiparams{'80211N'};

  $wlanapsettings{'WEPKEY1'}    = $cgiparams{'WEPKEY1'};
  $wlanapsettings{'WEPKEY2'}    = $cgiparams{'WEPKEY2'};
  $wlanapsettings{'WEPKEY3'}    = $cgiparams{'WEPKEY3'};
  $wlanapsettings{'WEPKEY4'}    = $cgiparams{'WEPKEY4'};
  $wlanapsettings{'USEDKEY'}    = $cgiparams{'USEDKEY'};

  $wlanapsettings{'PWD'}        = $cgiparams{'PWD'};
  $wlanapsettings{'PSK'}        = $cgiparams{'PSK'};
  $wlanapsettings{'WPA'}        = $cgiparams{'WPA'};
  $wlanapsettings{'WPAALGO'}    = $cgiparams{'WPAALGO'};
  $wlanapsettings{'WPA2ALGO'}   = $cgiparams{'WPA2ALGO'};
  $wlanapsettings{'WPAREKEY'}   = $cgiparams{'WPAREKEY'};

  $wlanapsettings{'SYSLOGLEVEL'}= $cgiparams{'SYSLOGLEVEL'};
  $wlanapsettings{'DEBUG'}      = $cgiparams{'DEBUG'};

  # verify WEP keys, allowed characters are 0..9A..F, length must be 10 or 26 characters
  for $i ( 1 .. 4 )
  {
    my $wepkey = $wlanapsettings{"WEPKEY${i}"};
    next if ( $wepkey eq '' );

    if ( (length($wepkey) != 10) && (length($wepkey) != 26) ) 
    {
      $errormessage .= "Invalid length in WEP Key $i. Key must be 10 or 26 characters.<br />";
      next;
    }

    if ( $wepkey !~ /[0-9A-Fa-f]$/ )
    {
      $errormessage .= "Invalid character in WEP Key $i. Only A..F and 0..9 allowed.<br />";
      next;
    }
    
    $wlanapsettings{"WEPKEY${i}"} = uc($wepkey);
  }

  # verify WPA Passphrase, must be 8 .. 63 characters
  if ( (length($wlanapsettings{'PWD'}) < 8) || (length($wlanapsettings{'PWD'}) > 63) ) 
  {
    $errormessage .= "Invalid length in WPA Passphrase. Must be between 8 and 63 characters.<br />";
  }

  if ( $errormessage eq '' ) 
  {
    &WriteConfig();
    &WriteConfig_wpa_supplicant();
    &WriteConfig_hostapd();

    system("/usr/local/bin/wlanapctrl --start >/dev/null 2>&1") if ( $cgiparams{'RUNNING'} eq 'on' );
  }
}
elsif ( $cgiparams{'ACTION'} eq 'Start' ) 
{
  system("/usr/local/bin/wlanapctrl --start >/dev/null 2>&1");
}
elsif ( $cgiparams{'ACTION'} eq 'Stop' ) 
{
  system("/usr/local/bin/wlanapctrl --stop >/dev/null 2>&1");
}
elsif ( $cgiparams{'ACTION'} eq 'Calc WEP Key' ) 
{
  $cgiparams{'WEPKEYCALC'} = '';
  $errormessage = "Invalid length in WEP Passphrase. Must be exactly 13 characters.<br />" if ( length($cgiparams{'WEPPWD'}) != 13 );

  if ( $errormessage eq '' ) 
  {
    $cgiparams{'WEPKEYCALC'} = uc(&WEPKeyCalc($cgiparams{'WEPPWD'}));
  }
}
elsif ( $cgiparams{'ACTION'} eq 'Random WEP Key' ) 
{
  $cgiparams{'WEPKEYCALC'} = &WEPKeyRandom();
}

&Header::openpage('WLAN', 1, '', '');
&Header::openbigbox('100%', 'left', '', $errormessage);
print "<form method='post' action='$ENV{'SCRIPT_NAME'}'>";

if ( $errormessage )
{
  &Header::openbox('100%', 'left', $Lang::tr{'error messages'}, 'error');
  print "<class name='base'>$errormessage\n";
  print "&nbsp;</class>\n";
  &Header::closebox();
}


#
# Check for new version
#
&checkfornewversion($addonname, $version);
if ( $onlineversion ne '' )
{
  &Header::openbox('100%', 'left', $Lang::tr{'info'}, 'warning');
  print <<END
<table width="100%"><tr>
<td>A new version is available: <a href="$onlinelink" target="_blank"><b>$onlineversion</b></a></td>
</tr></table>
END
;
  &Header::closebox();
}

#
# Driver and status detection
#
my $wlan_card           = 'down';
my $wlan_card_status    = $status_stopped;
my $wlan_ap_status      = $status_stopped;
my $wlan_hostapd_status = &General::isrunning('hostapd', 'nosize');
my $iw_status = '';

if ($netsettings{'BLUE_COUNT'} == 0) {
    $blue_message = 'No BLUE Interface.';
    $wlan_card = 'gone';
}
else {
    $iw_status = `/usr/local/bin/wlanapctrl --status 2>/dev/null`;

    if ($iw_status eq '') {
        $blue_message = "BLUE Interface is not a WLAN card.";
        $wlan_card = 'gone';
    }
    else {
        if (index($iw_status, ",UP") != -1) {
            $wlan_card = 'up' ;
            $wlan_card_status = $status_running;
            $wlan_ap_status = $status_running if (index($iw_status, "type AP") != -1);
        }
    }
}

my $disabled_apmode = "disabled='disabled'";
#$disabled_apmode = '' if ( ($wlanapsettings{'DRIVER'} eq 'ath9k') || ($wlanapsettings{'DRIVER'} eq 'HOSTAP') || ($wlanapsettings{'DRIVER'} eq 'ACX100') );
$disabled_apmode = '' if (index($iw_status, "* AP") != -1);
my $disabled_80211n = "disabled='disabled'";
$disabled_80211n = '' if (index($iw_status, "HT capabilities") == -1);

$checked{'APMODE'}{'off'} = '';
$checked{'APMODE'}{'on'}  = '';
$checked{'APMODE'}{$wlanapsettings{'APMODE'}} = "checked='checked'";
$checked{'BOOTSTART'}{'off'} = '';
$checked{'BOOTSTART'}{'on'}  = '';
$checked{'BOOTSTART'}{$wlanapsettings{'BOOTSTART'}} = "checked='checked'";
$checked{'HIDESSID'}{'off'} = '';
$checked{'HIDESSID'}{'on'}  = '';
$checked{'HIDESSID'}{$wlanapsettings{'HIDESSID'}} = "checked='checked'";
$checked{'80211N'}{'off'} = '';
$checked{'80211N'}{'on'}  = '';
$checked{'80211N'}{$wlanapsettings{'80211N'}} = "checked='checked'";

$selected{'ENC'}{'none'} = '';
$selected{'ENC'}{'wep'} = '';
$selected{'ENC'}{'wpa'} = '';
$selected{'ENC'}{'wep+wpa'} = '';
$selected{'ENC'}{$wlanapsettings{'ENC'}} = "selected='selected'";

$selected{'ANTENNA'}{'both'} = '';
$selected{'ANTENNA'}{'1'} = '';
$selected{'ANTENNA'}{'2'} = '';
$selected{'ANTENNA'}{$wlanapsettings{'ANTENNA'}} = "selected='selected'";

my @channellist;
# get available channels
if ( -e "/var/ipcop/addons/wlanap/channels" )
{
  open(CHANNELFILE, "/var/ipcop/addons/wlanap/channels");
  @channellist=<CHANNELFILE>;
  close CHANNELFILE;
  foreach $channel (@channellist) 
  {
    chomp($channel);
    $selected{'CHAN'}{$channel} = '';
  } 
  $selected{'CHAN'}{$wlanapsettings{'CHAN'}} = 'selected="selected"';
}
else
{
  $channellist[0] = '1';
  $selected{'CHAN'}{'1'} = 'selected="selected"';
}

my @txpowerlist;
# get available txpowers
if ( -e "/var/ipcop/addons/wlanap/txpower" )
{
  open(CHANNELFILE, "/var/ipcop/addons/wlanap/txpower");
  @txpowerlist=<CHANNELFILE>;
  close CHANNELFILE;
  foreach $txpower (@txpowerlist) 
  {
    chomp($txpower);
    $selected{'TXPOWER'}{$txpower} = '';
  } 
  $selected{'TXPOWER'}{$wlanapsettings{'TXPOWER'}} = 'selected="selected"';
}
else
{
  $txpowerlist[0] = 'auto';
  $selected{'TXPOWER'}{'auto'} = 'selected="selected"';
}

$selected{'USEDKEY'}{'1'} = '';
$selected{'USEDKEY'}{'2'} = '';
$selected{'USEDKEY'}{'3'} = '';
$selected{'USEDKEY'}{'4'} = '';
$selected{'USEDKEY'}{$wlanapsettings{'USEDKEY'}} = "selected='selected'";

$selected{'WPA'}{'1'} = '';
$selected{'WPA'}{'2'} = '';
$selected{'WPA'}{'3'} = '';
$selected{'WPA'}{$wlanapsettings{'WPA'}} = "selected='selected'";

$selected{'WPAALGO'}{'CCMP'} = '';
$selected{'WPAALGO'}{'TKIP'} = '';
$selected{'WPAALGO'}{'CCMP TKIP'} = '';
$selected{'WPAALGO'}{$wlanapsettings{'WPAALGO'}} = "selected='selected'";

$selected{'WPA2ALGO'}{'CCMP'} = '';
$selected{'WPA2ALGO'}{'TKIP'} = '';
$selected{'WPA2ALGO'}{'CCMP TKIP'} = '';
$selected{'WPA2ALGO'}{$wlanapsettings{'WPA2ALGO'}} = "selected='selected'";


$selected{'SYSLOGLEVEL'}{'0'} = '';
$selected{'SYSLOGLEVEL'}{'1'} = '';
$selected{'SYSLOGLEVEL'}{'2'} = '';
$selected{'SYSLOGLEVEL'}{'3'} = '';
$selected{'SYSLOGLEVEL'}{'4'} = '';
$selected{'SYSLOGLEVEL'}{$wlanapsettings{'SYSLOGLEVEL'}} = "selected='selected'";

$selected{'DEBUG'}{'0'} = '';
$selected{'DEBUG'}{'1'} = '';
$selected{'DEBUG'}{'2'} = '';
$selected{'DEBUG'}{'3'} = '';
$selected{'DEBUG'}{'4'} = '';
$selected{'DEBUG'}{$wlanapsettings{'DEBUG'}} = "selected='selected'";


#
# Status box
#
&Header::openbox('100%', 'left', "WLAN Status");
my $buttonstart = "<input type='submit' name='ACTION' value='Stop' /><input type='hidden' name='RUNNING' value='on' />";

print <<END
<table width='100%'><tr>
<td valign='top' width='50%'><table width='100%'>
<tr>
    <td width='50%'></td>
    <td width='50%'></td>
</tr>
END
;
if (($wlan_card eq 'up') || ($wlan_card eq 'down'))  {
    $buttonstart = "<input type='submit' name='ACTION' value='Start' />" if ($wlan_card ne 'up');

    print <<END
<tr>
    <td class='boldbase'>WLAN card ($netsettings{'BLUE_1_DRIVER'})</td>
    $wlan_card_status
</tr><tr>
    <td class='boldbase'>Access Point</td>
    $wlan_ap_status
</tr><tr>
    <td class='boldbase'>Hostapd</td>
    $wlan_hostapd_status
</tr>
END
    ;
}
else {
    $buttonstart = '&nbsp;';
    print <<END
<tr><td class='boldbase' colspan='2'>$blue_message</td></tr>
<tr><td class='boldbase' colspan='2'>Use setup on IPCop Console first to configure a BLUE interface.</td></tr>
END
    ;
}
print <<END
</table></td>
<td align='right'><a href='http://www.ban-solms.de/t/IPCop.html' target='_blank'><img src='/images/wlanap.png' alt='' /></a></td>
</tr></table>
<hr />
<table width='100%'>
<tr>
    <td class='comment1button'>WLAN AP [ $version ]</td>
    <td class='button1button'>$buttonstart</td>
    <td class='onlinehelp'></td>
</tr>
</table>
END
;
&Header::closebox();

if (($wlan_card ne 'up') && ($wlan_card ne 'down'))  {
    print "</form>";
    &Header::closebigbox();
    &Header::closepage();
    exit 0;
}


#
# WLAN settings
#
&Header::openbox('100%', 'left', "WLAN Settings");
print <<END
<table width='100%'>
<tr>
    <td width='25%'>Access Point:</td>
    <td colspan='3'><input type='checkbox' name='APMODE' $checked{'APMODE'}{'on'} $disabled_apmode /></td>
</tr><tr>
    <td width='25%'>SSID:&nbsp;</td>
    <td width='25%'><input type='text' name='SSID' size='25' value='$wlanapsettings{'SSID'}' /></td>
    <td width='25%'>Disable SSID broadcast:&nbsp;</td>
    <td width='25%'><input type='checkbox' name='HIDESSID' $checked{'HIDESSID'}{'on'} $disabled_apmode /></td>
</tr><tr>
    <td>Automatic start:</td>
    <td><input type='checkbox' name='BOOTSTART' $checked{'BOOTSTART'}{'on'} /></td>
    <td colspan='2'>Starts after Boot and Network Changes</td>
</tr><tr>
    <td>Encryption:</td>
    <td colspan='3'>
        <select name='ENC'>
            <option value='none' $selected{'ENC'}{'none'}>none</option>
            <option value='wep' $selected{'ENC'}{'wep'}>wep</option>
            <option value='wpa' $selected{'ENC'}{'wpa'}>wpa</option>
            <option value='wep+wpa' $selected{'ENC'}{'wep+wpa'}>wep+wpa</option>
        </select></td>
</tr><tr>
    <td>Use Antenna:&nbsp;</td>
    <td colspan='3'>
        <select name='ANTENNA'>
            <option value='both' $selected{'ANTENNA'}{'both'}>both</option>
            <option value='1' $selected{'ANTENNA'}{'1'}>1 only</option>
            <option value='2' $selected{'ANTENNA'}{'2'}>2 only</option>
        </select></td>
</tr>
<!-- <tr><td width='25%' class='base'>Select Country:&nbsp;</td><td class='base' colspan='3'><input type='checkbox' name='CC' $checked{'HIDESSID'}{'on'} /></td></tr> -->
<tr>
    <td>Channel:</td>
    <td colspan='3'><select name='CHAN'>
END
;
foreach $channel (@channellist) {
    print "<option $selected{'CHAN'}{$channel}>$channel</option>";
}
print <<END
        </select></td>
</tr><tr>
    <td>Tx Power:</td>
    <td colspan='3'><select name='TXPOWER'>
END
;
foreach $txpower (@txpowerlist) {
    print "<option $selected{'TXPOWER'}{$txpower}>$txpower</option>";
}
print <<END
        </select>&nbsp;dBm</td>
</tr><tr>
    <td>802.11n (Draft-N):&nbsp;</td>
    <td colspan='3'><input type='checkbox' name='80211N' $checked{'80211N'}{'on'} $disabled_80211n /></td>
</tr>
</table><hr /><table width='100%'>
<tr>
    <td class='comment1button'>&nbsp;</td>
    <td class='button1button'><input type='submit' name='ACTION' value='$Lang::tr{'save'}' /></td>
    <td class='onlinehelp'><a href='http://www.ban-solms.de/t/IPCop-wlanap-config.html#config' target='_blank'><img src='/images/web-support.png' title='online help' alt='online help' /></a></td>
</tr>
</table>
END
;
&Header::closebox();


#
# WPA
#
&Header::openbox('100%', 'left', "WPA Configuration");
print <<END
<table width='100%'>
<tr>
    <td width='25%'>Passphrase:</td>
    <td colspan='3'><input type='text' name='PWD' size='63' value='$wlanapsettings{'PWD'}' /></td>
</tr><tr>
    <td>WPA Version:</td>
    <td colspan='3'>
        <select name='WPA'>
            <option value='1' $selected{'WPA'}{'1'}>1</option>
            <option value='2' $selected{'WPA'}{'2'}>2</option>
            <option value='3' $selected{'WPA'}{'3'}>1+2</option>
        </select></td>
</tr><tr>
    <td>WPA Algorithm:</td>
    <td>
        <select name='WPAALGO'>
            <option value='CCMP' $selected{'WPAALGO'}{'CCMP'}>AES (CCMP)</option>
            <option value='TKIP' $selected{'WPAALGO'}{'TKIP'}>TKIP</option>
            <option value='CCMP TKIP' $selected{'WPAALGO'}{'CCMP TKIP'}>both</option>
        </select></td>
    <td>WPA2 Algorithm:</td>
    <td>
        <select name='WPA2ALGO'>
            <option value='CCMP' $selected{'WPA2ALGO'}{'CCMP'}>AES (CCMP)</option>
            <option value='TKIP' $selected{'WPA2ALGO'}{'TKIP'}>TKIP</option>
            <option value='CCMP TKIP' $selected{'WPA2ALGO'}{'CCMP TKIP'}>both</option>
        </select></td>
</tr><tr>
    <td>Group Key Renewal:</td>
    <td class='base' colspan='3'><input type='text' name='WPAREKEY' size='4' value='$wlanapsettings{'WPAREKEY'}' />&nbsp;seconds</td>
</tr><tr>
    <td width='25%'>Loglevel (hostapd):</td>
    <td width='25%'>
        <select name='SYSLOGLEVEL'>
            <option value='0' $selected{'SYSLOGLEVEL'}{'0'}>0 (verbose)</option>
            <option value='1' $selected{'SYSLOGLEVEL'}{'1'}>1 (debugging)</option>
            <option value='2' $selected{'SYSLOGLEVEL'}{'2'}>2 (informations)</option>
            <option value='3' $selected{'SYSLOGLEVEL'}{'3'}>3 (notifications)</option>
            <option value='4' $selected{'SYSLOGLEVEL'}{'4'}>4 (warnings)</option>
        </select></td>
    <td width='25%'>&nbsp;</td>
    <td width='25%'>&nbsp;</td>
</tr>
</table><hr /><table width='100%'>
<tr>
    <td class='comment1button'>&nbsp;</td>
    <td class='button1button'><input type='submit' name='ACTION' value='$Lang::tr{'save'}' /></td>
    <td class='onlinehelp'><a href='http://www.ban-solms.de/t/IPCop-wlanap-config.html#wpa' target='_blank'><img src='/images/web-support.png' title='online help' alt='online help' /></a></td>
</tr>
</table>
END
;
&Header::closebox();


#
# WEP
#
&Header::openbox('100%', 'left', "WEP Configuration");
print <<END
<table width='100%'>
<tr>
    <td width='25%'>Key 1:</td>
    <td width='25'><input type='text' name='WEPKEY1' size='32' value='$wlanapsettings{'WEPKEY1'}' /></td>
    <td width='25%'>&nbsp;</td>
    <td width='25%'>&nbsp;</td>
</tr><tr>
    <td>Key 2:&nbsp;<img src='/blob.gif' alt='*' /></td>
    <td colspan='3'><input type='text' name='WEPKEY2' size='32' value='$wlanapsettings{'WEPKEY2'}' /></td>
</tr><tr>
    <td>Key 3:&nbsp;<img src='/blob.gif' alt='*' /></td>
    <td colspan='3'><input type='text' name='WEPKEY3' size='32' value='$wlanapsettings{'WEPKEY3'}' /></td>
</tr><tr>
    <td>Key 4:&nbsp;<img src='/blob.gif' alt='*' /></td>
    <td colspan='3'><input type='text' name='WEPKEY4' size='32' value='$wlanapsettings{'WEPKEY4'}' /></td>
</tr><tr>
    <td>WEP Key to Use:</td>
    <td colspan='3'>
        <select name='USEDKEY'>
            <option value='1' $selected{'USEDKEY'}{'1'}>1</option>
            <option value='2' $selected{'USEDKEY'}{'2'}>2</option>
            <option value='3' $selected{'USEDKEY'}{'3'}>3</option>
            <option value='4' $selected{'USEDKEY'}{'4'}>4</option>
        </select></td>
</tr><tr>
    <td colspan='4'><hr /></td>
</tr><tr>
    <td>Passphrase:</td>
    <td><input type='text' name='WEPPWD' size='13' value='$cgiparams{'WEPPWD'}' /></td>
    <td align='center'><input type='submit' name='ACTION' value='Calc WEP Key' /></td>
    <td>&nbsp;</td>
</tr><tr>
    <td>WEP Key:</td>
    <td><input type='text' name='WEPKEYCALC' size='32' value='$cgiparams{'WEPKEYCALC'}' /></td>
    <td align='center'><input type='submit' name='ACTION' value='Random WEP Key' /></td>
    <td>&nbsp;</td>
</tr>
</table><hr /><table width='100%'>
<tr>
    <td class='comment1button'>&nbsp;</td>
    <td class='button1button'><input type='submit' name='ACTION' value='$Lang::tr{'save'}' /></td>
    <td class='onlinehelp'><a href='http://www.ban-solms.de/t/IPCop-wlanap-config.html#wep' target='_blank'><img src='/images/web-support.png' title='online help' alt='online help' /></a></td>
</tr>
</table>
END
;
&Header::closebox();


print "</form>";
&Header::closebigbox();
&Header::closepage();


sub checkfornewversion
{
  my $addon = shift;
  my $version = shift;
  $onlineversion = '';

  if ( -e $flagdonotcheck )
  {
    return;
  }

  # only check if we are online and last check was some time ago
  if ( (! -e '/var/ipcop/red/active') || (-e $timestamplastcheck) && (int(-M $timestamplastcheck) < 5) )
  {
    return;
  }

#workaround to suppress a warning when a variable is used only once
  my @dummy = ( $General::version );
  undef (@dummy);

  my $ua = LWP::UserAgent->new;
  $ua->timeout(120);
  $ua->agent("Mozilla/4.0 (compatible; IPCop $General::version; $version)");
  my $content = $ua->get("http://www.ban-solms.de/version/$addon");

  if ( $content->is_success )
  {
    # compare the versions, format is v1.2.3
    $content->content =~ /v(\d+).(\d+).(\d+)/;
    my $ver1 = $1;
    my $ver2 = $2;
    my $ver3 = $3;

    $version =~ /v(\d+).(\d+).(\d+)/;

    if ( ($ver1 > $1) || (($ver1 == $1) && ($ver2 > $2)) || (($ver1 == $1) && ($ver2 == $2) && ($ver3 > $3)) )
    {
      $onlineversion = "v$ver1.$ver2.$ver3";

      $content->content =~ /http(.*)/;
      $onlinelink = "http$1";
    }
    else
    {
      # no news, recheck in a couple of days
      system("touch $timestamplastcheck");
    }
  }
}


sub WEPKeyRandom
{
  my $length = 26;      # 10 is also allowed
  my $string = "0123456789ABCDEF";
  my @chars = split(//,$string);
  my $n = @chars; 
  my $index;
  my $key = '';
  for ( $i = 0; $i < $length; $i++) 
  {
    $index = int(rand $n);
    $key = $key . $chars[$index];
  }
  return $key;
}


sub WEPKeyCalc
{
  require Digest::MD5;

  return substr Digest::MD5::md5_hex( substr( shift() x 64, 0, 64 ) ), 0, 26;
}


sub WriteConfig
{
  &General::writehash("/var/ipcop/addons/wlanap/settings", \%wlanapsettings);
}


sub WriteConfig_wpa_supplicant
{
    open (CONFIGFILE, ">/var/ipcop/addons/wlanap/wpa_supplicant.conf");
    print CONFIGFILE <<END

network={
    ssid="$wlanapsettings{'SSID'}"
    scan_ssid=1
    key_mgmt=WPA-PSK
    proto=WPA RSN
    pairwise=$wlanapsettings{'WPAALGO'}
    group=CCMP TKIP
    psk="$wlanapsettings{'PWD'}"
}
END
    ;
    close CONFIGFILE;
}


sub WriteConfig_hostapd
{
    $wlanapsettings{'DRIVER_HOSTAPD'} = lc($wlanapsettings{'DRIVER'});
    $wlanapsettings{'DRIVER_HOSTAPD'} = 'nl80211';

    my $key = "WEPKEY$wlanapsettings{'USEDKEY'}";
    my $wpa = $wlanapsettings{'WPA'};
    $wpa = 0 if (($wlanapsettings{'ENC'} eq 'none') || ($wlanapsettings{'ENC'} eq 'wep'));
    
    my $ieee80211n = ($wlanapsettings{'80211N'} eq 'on') ? 1 : 0;
    my $ht_capab = '';
    my $broadcast_ssid = ($wlanapsettings{'HIDESSID'} eq 'on') ? 2 : 0;

    open (CONFIGFILE, ">/var/ipcop/addons/wlanap/hostapd.conf");
    print CONFIGFILE <<END
##### hostapd configuration file ##############################################
# Empty lines and lines starting with # are ignored

# AP netdevice name (without 'ap' postfix, i.e., wlan0 uses wlan0ap for
# management frames); ath0 for madwifi
interface=$netsettings{'BLUE_1_DEV'}

# Driver interface type (hostap/wired/madwifi/prism54/test/none/nl80211/bsd);
# default: hostap). nl80211 is used with all Linux mac80211 drivers.
driver=$wlanapsettings{'DRIVER_HOSTAPD'}

# hostapd event logger configuration
#
# Two output method: syslog and stdout (only usable if not forking to
# background).
#
# Module bitfield (ORed bitfield of modules that will be logged; -1 = all
# modules):
# bit 0 (1) = IEEE 802.11
# bit 1 (2) = IEEE 802.1X
# bit 2 (4) = RADIUS
# bit 3 (8) = WPA
# bit 4 (16) = driver interface
# bit 5 (32) = IAPP
# bit 6 (64) = MLME
#
# Levels (minimum value for logged events):
#  0 = verbose debugging
#  1 = debugging
#  2 = informational messages
#  3 = notification
#  4 = warning
#
logger_syslog=-1
logger_syslog_level=$wlanapsettings{'SYSLOGLEVEL'}
logger_stdout=-1
logger_stdout_level=$wlanapsettings{'SYSLOGLEVEL'}

# Dump file for state information (on SIGUSR1)
dump_file=/tmp/hostapd.dump


##### IEEE 802.11 related configuration #######################################

# SSID to be used in IEEE 802.11 management frames
ssid=$wlanapsettings{'SSID'}

# Country code (ISO/IEC 3166-1). Used to set regulatory domain.
# Set as needed to indicate country in which device is operating.
# This can limit available channels and transmit power.
#country_code=US

# Enable IEEE 802.11d. This advertises the country_code and the set of allowed
# channels and transmit power levels based on the regulatory limits. The
# country_code setting must be configured with the correct country for
# IEEE 802.11d functions.
# (default: 0 = disabled)
#ieee80211d=1

# Operation mode (a = IEEE 802.11a, b = IEEE 802.11b, g = IEEE 802.11g,
# Default: IEEE 802.11b
hw_mode=g

# Channel number (IEEE 802.11)
# (default: 0, i.e., not set)
# Please note that some drivers (e.g., madwifi) do not use this value from
# hostapd and the channel will need to be configuration separately with
# iwconfig.
channel=$wlanapsettings{'CHAN'}

# Beacon interval in kus (1.024 ms) (default: 100; range 15..65535)
beacon_int=100

# DTIM (delivery trafic information message) period (range 1..255):
# number of beacons between DTIMs (1 = every beacon includes DTIM element)
# (default: 2)
dtim_period=2

# Maximum number of stations allowed in station table. New stations will be
# rejected after the station table is full. IEEE 802.11 has a limit of 2007
# different association IDs, so this number should not be larger than that.
# (default: 2007)
max_num_sta=255

# RTS/CTS threshold; 2347 = disabled (default); range 0..2347
# If this field is not included in hostapd.conf, hostapd will not control
# RTS threshold and 'iwconfig wlan# rts <val>' can be used to set it.
rts_threshold=2347

# Fragmentation threshold; 2346 = disabled (default); range 256..2346
# If this field is not included in hostapd.conf, hostapd will not control
# fragmentation threshold and 'iwconfig wlan# frag <val>' can be used to set
# it.
fragm_threshold=2346

# Rate configuration
# Default is to enable all rates supported by the hardware. This configuration
# item allows this list be filtered so that only the listed rates will be left
# in the list. If the list is empty, all rates are used. This list can have
# entries that are not in the list of rates the hardware supports (such entries
# are ignored). The entries in this list are in 100 kbps, i.e., 11 Mbps = 110.
# If this item is present, at least one rate have to be matching with the rates
# hardware supports.
# default: use the most common supported rate setting for the selected
# hw_mode (i.e., this line can be removed from configuration file in most
# cases)
#supported_rates=10 20 55 110 60 90 120 180 240 360 480 540

# Basic rate set configuration
# List of rates (in 100 kbps) that are included in the basic rate set.
# If this item is not included, usually reasonable default set is used.
#basic_rates=10 20
#basic_rates=10 20 55 110
#basic_rates=60 120 240

# Short Preamble
# This parameter can be used to enable optional use of short preamble for
# frames sent at 2 Mbps, 5.5 Mbps, and 11 Mbps to improve network performance.
# This applies only to IEEE 802.11b-compatible networks and this should only be
# enabled if the local hardware supports use of short preamble. If any of the
# associated STAs do not support short preamble, use of short preamble will be
# disabled (and enabled when such STAs disassociate) dynamically.
# 0 = do not allow use of short preamble (default)
# 1 = allow use of short preamble
#preamble=1

# Station MAC address -based authentication
# Please note that this kind of access control requires a driver that uses
# hostapd to take care of management frame processing and as such, this can be
# used with driver=hostap or driver=nl80211, but not with driver=madwifi.
# 0 = accept unless in deny list
# 1 = deny unless in accept list
# 2 = use external RADIUS server (accept/deny lists are searched first)
macaddr_acl=0

# Accept/deny lists are read from separate files (containing list of
# MAC addresses, one per line). Use absolute path name to make sure that the
# files can be read on SIGHUP configuration reloads.
#accept_mac_file=/etc/hostapd.accept
#deny_mac_file=/etc/hostapd.deny

# IEEE 802.11 specifies two authentication algorithms. hostapd can be
# configured to allow both of these or only one. Open system authentication
# should be used with IEEE 802.1X.
# Bit fields of allowed authentication algorithms:
# bit 0 = Open System Authentication
# bit 1 = Shared Key Authentication (requires WEP)
auth_algs=3

# Send empty SSID in beacons and ignore probe request frames that do not
# specify full SSID, i.e., require stations to know SSID.
# default: disabled (0)
# 1 = send empty (length=0) SSID in beacon and ignore probe request for
#     broadcast SSID
# 2 = clear SSID (ASCII 0), but keep the original length (this may be required
#     with some clients that do not support empty SSID) and ignore probe
#     requests for broadcast SSID
ignore_broadcast_ssid=$broadcast_ssid

# TX queue parameters (EDCF / bursting)
# default for all these fields: not set, use hardware defaults
# tx_queue_<queue name>_<param>
# queues: data0, data1, data2, data3, after_beacon, beacon
#		(data0 is the highest priority queue)
# parameters:
#   aifs: AIFS (default 2)
#   cwmin: cwMin (1, 3, 7, 15, 31, 63, 127, 255, 511, 1023)
#   cwmax: cwMax (1, 3, 7, 15, 31, 63, 127, 255, 511, 1023); cwMax >= cwMin
#   burst: maximum length (in milliseconds with precision of up to 0.1 ms) for
#          bursting
#
# Default WMM parameters (IEEE 802.11 draft; 11-03-0504-03-000e):
# These parameters are used by the access point when transmitting frames
# to the clients.
#
# Low priority / AC_BK = background
#tx_queue_data3_aifs=7
#tx_queue_data3_cwmin=15
#tx_queue_data3_cwmax=1023
#tx_queue_data3_burst=0
# Note: for IEEE 802.11b mode: cWmin=31 cWmax=1023 burst=0
#
# Normal priority / AC_BE = best effort
#tx_queue_data2_aifs=3
#tx_queue_data2_cwmin=15
#tx_queue_data2_cwmax=63
#tx_queue_data2_burst=0
# Note: for IEEE 802.11b mode: cWmin=31 cWmax=127 burst=0
#
# High priority / AC_VI = video
#tx_queue_data1_aifs=1
#tx_queue_data1_cwmin=7
#tx_queue_data1_cwmax=15
#tx_queue_data1_burst=3.0
# Note: for IEEE 802.11b mode: cWmin=15 cWmax=31 burst=6.0
#
# Highest priority / AC_VO = voice
#tx_queue_data0_aifs=1
#tx_queue_data0_cwmin=3
#tx_queue_data0_cwmax=7
#tx_queue_data0_burst=1.5
# Note: for IEEE 802.11b mode: cWmin=7 cWmax=15 burst=3.3
#
# Special queues; normally not user configurable
#
#tx_queue_after_beacon_aifs=2
#tx_queue_after_beacon_cwmin=15
#tx_queue_after_beacon_cwmax=1023
#tx_queue_after_beacon_burst=0
#
#tx_queue_beacon_aifs=2
#tx_queue_beacon_cwmin=3
#tx_queue_beacon_cwmax=7
#tx_queue_beacon_burst=1.5

# 802.1D Tag (= UP) to AC mappings
# WMM specifies following mapping of data frames to different ACs. This mapping
# can be configured using Linux QoS/tc and sch_pktpri.o module.
# 802.1D Tag	802.1D Designation	Access Category	WMM Designation
# 1		BK			AC_BK		Background
# 2		-			AC_BK		Background
# 0		BE			AC_BE		Best Effort
# 3		EE			AC_BE		Best Effort
# 4		CL			AC_VI		Video
# 5		VI			AC_VI		Video
# 6		VO			AC_VO		Voice
# 7		NC			AC_VO		Voice
# Data frames with no priority information: AC_BE
# Management frames: AC_VO
# PS-Poll frames: AC_BE

# Default WMM parameters (IEEE 802.11 draft; 11-03-0504-03-000e):
# for 802.11a or 802.11g networks
# These parameters are sent to WMM clients when they associate.
# The parameters will be used by WMM clients for frames transmitted to the
# access point.
#
# note - txop_limit is in units of 32microseconds
# note - acm is admission control mandatory flag. 0 = admission control not
# required, 1 = mandatory
# note - here cwMin and cmMax are in exponent form. the actual cw value used
# will be (2^n)-1 where n is the value given here
#
wme_enabled=0
#
# Low priority / AC_BK = background
wme_ac_bk_cwmin=4
wme_ac_bk_cwmax=10
wme_ac_bk_aifs=7
wme_ac_bk_txop_limit=0
wme_ac_bk_acm=0
# Note: for IEEE 802.11b mode: cWmin=5 cWmax=10
#
# Normal priority / AC_BE = best effort
wme_ac_be_aifs=3
wme_ac_be_cwmin=4
wme_ac_be_cwmax=10
wme_ac_be_txop_limit=0
wme_ac_be_acm=0
# Note: for IEEE 802.11b mode: cWmin=5 cWmax=7
#
# High priority / AC_VI = video
wme_ac_vi_aifs=2
wme_ac_vi_cwmin=3
wme_ac_vi_cwmax=4
wme_ac_vi_txop_limit=94
wme_ac_vi_acm=0
# Note: for IEEE 802.11b mode: cWmin=4 cWmax=5 txop_limit=188
#
# Highest priority / AC_VO = voice
wme_ac_vo_aifs=2
wme_ac_vo_cwmin=2
wme_ac_vo_cwmax=3
wme_ac_vo_txop_limit=47
wme_ac_vo_acm=0
# Note: for IEEE 802.11b mode: cWmin=3 cWmax=4 burst=102

# Station inactivity limit
#
# If a station does not send anything in ap_max_inactivity seconds, an
# empty data frame is sent to it in order to verify whether it is
# still in range. If this frame is not ACKed, the station will be
# disassociated and then deauthenticated. This feature is used to
# clear station table of old entries when the STAs move out of the
# range.
#
# The station can associate again with the AP if it is still in range;
# this inactivity poll is just used as a nicer way of verifying
# inactivity; i.e., client will not report broken connection because
# disassociation frame is not sent immediately without first polling
# the STA with a data frame.
# default: 300 (i.e., 5 minutes)
#ap_max_inactivity=300

# Enable/disable internal bridge for packets between associated stations.
#
# When IEEE 802.11 is used in managed mode, packets are usually send through
# the AP even if they are from a wireless station to another wireless station.
# This functionality requires that the AP has a bridge functionality that sends
# frames back to the same interface if their destination is another associated
# station. In addition, broadcast/multicast frames from wireless stations will
# be sent both to the host system net stack (e.g., to eventually wired network)
# and back to the wireless interface.
#
# The internal bridge is implemented within the wireless kernel module and it
# bypasses kernel filtering (netfilter/iptables/ebtables). If direct
# communication between the stations needs to be prevented, the internal
# bridge can be disabled by setting bridge_packets=0.
#
# Note: If this variable is not included in hostapd.conf, hostapd does not
# change the configuration and iwpriv can be used to set the value with
# 'iwpriv wlan# param 10 0' command. If the variable is in hostapd.conf,
# hostapd will override possible iwpriv configuration whenever configuration
# file is reloaded.
#
# default: do not control from hostapd (80211.o defaults to 1=enabled)
#bridge_packets=1

# Maximum allowed Listen Interval (how many Beacon periods STAs are allowed to
# remain asleep). Default: 65535 (no limit apart from field size)
#max_listen_interval=100

##### IEEE 802.11n related configuration ######################################

# ieee80211n: Whether IEEE 802.11n (HT) is enabled
# 0 = disabled (default)
# 1 = enabled
ieee80211n=$ieee80211n

# ht_capab: HT capabilities (list of flags)
# LDPC coding capability: [LDPC] = supported
# Supported channel width set: [HT40-] = both 20 MHz and 40 MHz with secondary
#	channel below the primary channel; [HT40+] = both 20 MHz and 40 MHz
#	with secondary channel below the primary channel
#	(20 MHz only if neither is set)
#	Note: There are limits on which channels can be used with HT40- and
#	HT40+. Following table shows the channels that may be available for
#	HT40- and HT40+ use per IEEE 802.11n Annex J:
#	freq		HT40-		HT40+
#	2.4 GHz		5-13		1-7 (1-9 in Europe/Japan)
#	5 GHz		40,48,56,64	36,44,52,60
#	(depending on the location, not all of these channels may be available
#	for use)
# Spatial Multiplexing (SM) Power Save: [SMPS-STATIC] or [SMPS-DYNAMIC]
#	(SMPS disabled if neither is set)
# HT-greenfield: [GF] (disabled if not set)
# Short GI for 20 MHz: [SHORT-GI-20] (disabled if not set)
# Short GI for 40 MHz: [SHORT-GI-40] (disabled if not set)
# Tx STBC: [TX-STBC] (disabled if not set)
# Rx STBC: [RX-STBC1] (one spatial stream), [RX-STBC12] (one or two spatial
#	streams), or [RX-STBC123] (one, two, or three spatial streams); Rx STBC
#	disabled if none of these set
# HT-delayed Block Ack: [DELAYED-BA] (disabled if not set)
# Maximum A-MSDU length: [MAX-AMSDU-7935] for 7935 octets (3839 octets if not
#	set)
# DSSS/CCK Mode in 40 MHz: [DSSS_CCK-40] = allowed (not allowed if not set)
# PSMP support: [PSMP] (disabled if not set)
# L-SIG TXOP protection support: [LSIG-TXOP-PROT] (disabled if not set)
ht_capab=$ht_capab

##### IEEE 802.1X-2004 related configuration ##################################

# Require IEEE 802.1X authorization
#ieee8021x=1

# EAPOL-Key index workaround (set bit7) for WinXP Supplicant (needed only if
# only broadcast keys are used)
eapol_key_index_workaround=0

##### Integrated EAP server ###################################################

# Optionally, hostapd can be configured to use an integrated EAP server
# to process EAP authentication locally without need for an external RADIUS
# server. This functionality can be used both as a local authentication server
# for IEEE 802.1X/EAPOL and as a RADIUS server for other devices.

# Use integrated EAP server instead of external RADIUS authentication
# server. This is also needed if hostapd is configured to act as a RADIUS
# authentication server.
eap_server=0

# Path for EAP server user database
#eap_user_file=/etc/hostapd.eap_user

# CA certificate (PEM or DER file) for EAP-TLS/PEAP/TTLS
#ca_cert=/etc/hostapd.ca.pem

# Server certificate (PEM or DER file) for EAP-TLS/PEAP/TTLS
#server_cert=/etc/hostapd.server.pem

# Private key matching with the server certificate for EAP-TLS/PEAP/TTLS
# This may point to the same file as server_cert if both certificate and key
# are included in a single file. PKCS#12 (PFX) file (.p12/.pfx) can also be
# used by commenting out server_cert and specifying the PFX file as the
# private_key.
#private_key=/etc/hostapd.server.prv

# Passphrase for private key
#private_key_passwd=secret passphrase

# Enable CRL verification.
# Note: hostapd does not yet support CRL downloading based on CDP. Thus, a
# valid CRL signed by the CA is required to be included in the ca_cert file.
# This can be done by using PEM format for CA certificate and CRL and
# concatenating these into one file. Whenever CRL changes, hostapd needs to be
# restarted to take the new CRL into use.
# 0 = do not verify CRLs (default)
# 1 = check the CRL of the user certificate
# 2 = check all CRLs in the certificate path
#check_crl=1

# dh_file: File path to DH/DSA parameters file (in PEM format)
# This is an optional configuration file for setting parameters for an
# ephemeral DH key exchange. In most cases, the default RSA authentication does
# not use this configuration. However, it is possible setup RSA to use
# ephemeral DH key exchange. In addition, ciphers with DSA keys always use
# ephemeral DH keys. This can be used to achieve forward secrecy. If the file
# is in DSA parameters format, it will be automatically converted into DH
# params. This parameter is required if anonymous EAP-FAST is used.
# You can generate DH parameters file with OpenSSL, e.g.,
# "openssl dhparam -out /etc/hostapd.dh.pem 1024"
#dh_file=/etc/hostapd.dh.pem

# Configuration data for EAP-SIM database/authentication gateway interface.
# This is a text string in implementation specific format. The example
# implementation in eap_sim_db.c uses this as the UNIX domain socket name for
# the HLR/AuC gateway (e.g., hlr_auc_gw). In this case, the path uses "unix:"
# prefix.
#eap_sim_db=unix:/tmp/hlr_auc_gw.sock

# Encryption key for EAP-FAST PAC-Opaque values. This key must be a secret,
# random value. It is configured as a 16-octet value in hex format. It can be
# generated, e.g., with the following command:
# od -tx1 -v -N16 /dev/random | colrm 1 8 | tr -d ' '
#pac_opaque_encr_key=000102030405060708090a0b0c0d0e0f

# EAP-FAST authority identity (A-ID)
# A-ID indicates the identity of the authority that issues PACs. The A-ID
# should be unique across all issuing servers. In theory, this is a variable
# length field, but due to some existing implementations required A-ID to be
# 16 octets in length, it is strongly recommended to use that length for the
# field to provided interoperability with deployed peer implementation. This
# field is configured in hex format.
#eap_fast_a_id=101112131415161718191a1b1c1d1e1f

# EAP-FAST authority identifier information (A-ID-Info)
# This is a user-friendly name for the A-ID. For example, the enterprise name
# and server name in a human-readable format. This field is encoded as UTF-8.
#eap_fast_a_id_info=test server

# Enable/disable different EAP-FAST provisioning modes:
#0 = provisioning disabled
#1 = only anonymous provisioning allowed
#2 = only authenticated provisioning allowed
#3 = both provisioning modes allowed (default)
#eap_fast_prov=3

# EAP-FAST PAC-Key lifetime in seconds (hard limit)
#pac_key_lifetime=604800

# EAP-FAST PAC-Key refresh time in seconds (soft limit on remaining hard
# limit). The server will generate a new PAC-Key when this number of seconds
# (or fewer) of the lifetime remains.
#pac_key_refresh_time=86400

# EAP-SIM and EAP-AKA protected success/failure indication using AT_RESULT_IND
# (default: 0 = disabled).
#eap_sim_aka_result_ind=1

# Trusted Network Connect (TNC)
# If enabled, TNC validation will be required before the peer is allowed to
# connect. Note: This is only used with EAP-TTLS and EAP-FAST. If any other
# EAP method is enabled, the peer will be allowed to connect without TNC.
#tnc=1


##### IEEE 802.11f - Inter-Access Point Protocol (IAPP) #######################

# Interface to be used for IAPP broadcast packets
#iapp_interface=eth0


##### RADIUS client configuration #############################################
# for IEEE 802.1X with external Authentication Server, IEEE 802.11
# authentication with external ACL for MAC addresses, and accounting

# The own IP address of the access point (used as NAS-IP-Address)
own_ip_addr=127.0.0.1

# Optional NAS-Identifier string for RADIUS messages. When used, this should be
# a unique to the NAS within the scope of the RADIUS server. For example, a
# fully qualified domain name can be used here.
# When using IEEE 802.11r, nas_identifier must be set and must be between 1 and
# 48 octets long.
#nas_identifier=ap.example.com

# RADIUS authentication server
#auth_server_addr=127.0.0.1
#auth_server_port=1812
#auth_server_shared_secret=secret

# RADIUS accounting server
#acct_server_addr=127.0.0.1
#acct_server_port=1813
#acct_server_shared_secret=secret

# Secondary RADIUS servers; to be used if primary one does not reply to
# RADIUS packets. These are optional and there can be more than one secondary
# server listed.
#auth_server_addr=127.0.0.2
#auth_server_port=1812
#auth_server_shared_secret=secret2
#
#acct_server_addr=127.0.0.2
#acct_server_port=1813
#acct_server_shared_secret=secret2

# Retry interval for trying to return to the primary RADIUS server (in
# seconds). RADIUS client code will automatically try to use the next server
# when the current server is not replying to requests. If this interval is set,
# primary server will be retried after configured amount of time even if the
# currently used secondary server is still working.
#radius_retry_primary_interval=600


# Interim accounting update interval
# If this is set (larger than 0) and acct_server is configured, hostapd will
# send interim accounting updates every N seconds. Note: if set, this overrides
# possible Acct-Interim-Interval attribute in Access-Accept message. Thus, this
# value should not be configured in hostapd.conf, if RADIUS server is used to
# control the interim interval.
# This value should not be less 600 (10 minutes) and must not be less than
# 60 (1 minute).
#radius_acct_interim_interval=600

# Dynamic VLAN mode; allow RADIUS authentication server to decide which VLAN
# is used for the stations. This information is parsed from following RADIUS
# attributes based on RFC 3580 and RFC 2868: Tunnel-Type (value 13 = VLAN),
# Tunnel-Medium-Type (value 6 = IEEE 802), Tunnel-Private-Group-ID (value
# VLANID as a string). vlan_file option below must be configured if dynamic
# VLANs are used. Optionally, the local MAC ACL list (accept_mac_file) can be
# used to set static client MAC address to VLAN ID mapping.
# 0 = disabled (default)
# 1 = option; use default interface if RADIUS server does not include VLAN ID
# 2 = required; reject authentication if RADIUS server does not include VLAN ID
#dynamic_vlan=0

# VLAN interface list for dynamic VLAN mode is read from a separate text file.
# This list is used to map VLAN ID from the RADIUS server to a network
# interface. Each station is bound to one interface in the same way as with
# multiple BSSIDs or SSIDs. Each line in this text file is defining a new
# interface and the line must include VLAN ID and interface name separated by
# white space (space or tab).
#vlan_file=/etc/hostapd.vlan

# Interface where 802.1q tagged packets should appear when a RADIUS server is
# used to determine which VLAN a station is on.  hostapd creates a bridge for
# each VLAN.  Then hostapd adds a VLAN interface (associated with the interface
# indicated by 'vlan_tagged_interface') and the appropriate wireless interface
# to the bridge.
#vlan_tagged_interface=eth0


##### RADIUS authentication server configuration ##############################

# hostapd can be used as a RADIUS authentication server for other hosts. This
# requires that the integrated EAP server is also enabled and both
# authentication services are sharing the same configuration.

# File name of the RADIUS clients configuration for the RADIUS server. If this
# commented out, RADIUS server is disabled.
#radius_server_clients=/etc/hostapd.radius_clients

# The UDP port number for the RADIUS authentication server
#radius_server_auth_port=1812

# Use IPv6 with RADIUS server (IPv4 will also be supported using IPv6 API)
#radius_server_ipv6=1


##### WPA/IEEE 802.11i configuration ##########################################

# Enable WPA. Setting this variable configures the AP to require WPA (either
# WPA-PSK or WPA-RADIUS/EAP based on other configuration). For WPA-PSK, either
# wpa_psk or wpa_passphrase must be set and wpa_key_mgmt must include WPA-PSK.
# For WPA-RADIUS/EAP, ieee8021x must be set (but without dynamic WEP keys),
# RADIUS authentication server must be configured, and WPA-EAP must be included
# in wpa_key_mgmt.
# This field is a bit field that can be used to enable WPA (IEEE 802.11i/D3.0)
# and/or WPA2 (full IEEE 802.11i/RSN):
# bit0 = WPA
# bit1 = IEEE 802.11i/RSN (WPA2) (dot11RSNAEnabled)
wpa=$wpa

# WPA pre-shared keys for WPA-PSK. This can be either entered as a 256-bit
# secret in hex format (64 hex digits), wpa_psk, or as an ASCII passphrase
# (8..63 characters) that will be converted to PSK. This conversion uses SSID
# so the PSK changes when ASCII passphrase is used and the SSID is changed.
# wpa_psk (dot11RSNAConfigPSKValue)
# wpa_passphrase (dot11RSNAConfigPSKPassPhrase)
#wpa_psk=0123456789abcdef0123456789abcdef0123456789abcdef0123456789abcdef
wpa_passphrase=$wlanapsettings{'PWD'}

# Optionally, WPA PSKs can be read from a separate text file (containing list
# of (PSK,MAC address) pairs. This allows more than one PSK to be configured.
# Use absolute path name to make sure that the files can be read on SIGHUP
# configuration reloads.
#wpa_psk_file=/etc/hostapd.wpa_psk

# Set of accepted key management algorithms (WPA-PSK, WPA-EAP, or both). The
# entries are separated with a space.
# (dot11RSNAConfigAuthenticationSuitesTable)
wpa_key_mgmt=WPA-PSK

# Set of accepted cipher suites (encryption algorithms) for pairwise keys
# (unicast packets). This is a space separated list of algorithms:
# CCMP = AES in Counter mode with CBC-MAC [RFC 3610, IEEE 802.11i/D7.0]
# TKIP = Temporal Key Integrity Protocol [IEEE 802.11i/D7.0]
# Group cipher suite (encryption algorithm for broadcast and multicast frames)
# is automatically selected based on this configuration. If only CCMP is
# allowed as the pairwise cipher, group cipher will also be CCMP. Otherwise,
# TKIP will be used as the group cipher.
# (dot11RSNAConfigPairwiseCiphersTable)
# Pairwise cipher for WPA (v1) (default: TKIP)
wpa_pairwise=$wlanapsettings{'WPAALGO'}
# Pairwise cipher for RSN/WPA2 (default: use wpa_pairwise value)
rsn_pairwise=$wlanapsettings{'WPA2ALGO'}

# Time interval for rekeying GTK (broadcast/multicast encryption keys) in
# seconds. (dot11RSNAConfigGroupRekeyTime)
wpa_group_rekey=$wlanapsettings{'WPAREKEY'}

# Rekey GTK when any STA that possesses the current GTK is leaving the BSS.
# (dot11RSNAConfigGroupRekeyStrict)
#wpa_strict_rekey=1

# Time interval for rekeying GMK (master key used internally to generate GTKs
# (in seconds).
#wpa_gmk_rekey=86400

# Maximum lifetime for PTK in seconds. This can be used to enforce rekeying of
# PTK to mitigate some attacks against TKIP deficiencies.
#wpa_ptk_rekey=600

# Enable IEEE 802.11i/RSN/WPA2 pre-authentication. This is used to speed up
# roaming be pre-authenticating IEEE 802.1X/EAP part of the full RSN
# authentication and key handshake before actually associating with a new AP.
# (dot11RSNAPreauthenticationEnabled)
#rsn_preauth=1
#
# Space separated list of interfaces from which pre-authentication frames are
# accepted (e.g., 'eth0' or 'eth0 wlan0wds0'. This list should include all
# interface that are used for connections to other APs. This could include
# wired interfaces and WDS links. The normal wireless data interface towards
# associated stations (e.g., wlan0) should not be added, since
# pre-authentication is only used with APs other than the currently associated
# one.
#rsn_preauth_interfaces=eth0

# peerkey: Whether PeerKey negotiation for direct links (IEEE 802.11e) is
# allowed. This is only used with RSN/WPA2.
# 0 = disabled (default)
# 1 = enabled
#peerkey=1

# ieee80211w: Whether management frame protection (MFP) is enabled
# 0 = disabled (default)
# 1 = optional
# 2 = required
#ieee80211w=0

# Association SA Query maximum timeout (in TU = 1.024 ms; for MFP)
# (maximum time to wait for a SA Query response)
# dot11AssociationSAQueryMaximumTimeout, 1...4294967295
#assoc_sa_query_max_timeout=1000

# Association SA Query retry timeout (in TU = 1.024 ms; for MFP)
# (time between two subsequent SA Query requests)
# dot11AssociationSAQueryRetryTimeout, 1...4294967295
#assoc_sa_query_retry_timeout=201


# okc: Opportunistic Key Caching (aka Proactive Key Caching)
# Allow PMK cache to be shared opportunistically among configured interfaces
# and BSSes (i.e., all configurations within a single hostapd process).
# 0 = disabled (default)
# 1 = enabled
#okc=1


##### IEEE 802.11r configuration ##############################################

# Mobility Domain identifier (dot11FTMobilityDomainID, MDID)
# MDID is used to indicate a group of APs (within an ESS, i.e., sharing the
# same SSID) between which a STA can use Fast BSS Transition.
# 2-octet identifier as a hex string.
#mobility_domain=a1b2

# PMK-R0 Key Holder identifier (dot11FTR0KeyHolderID)
# 1 to 48 octet identifier.
# This is configured with nas_identifier (see RADIUS client section above).

# Default lifetime of the PMK-RO in minutes; range 1..65535
# (dot11FTR0KeyLifetime)
#r0_key_lifetime=10000

# PMK-R1 Key Holder identifier (dot11FTR1KeyHolderID)
# 6-octet identifier as a hex string.
#r1_key_holder=000102030405

# Reassociation deadline in time units (TUs / 1.024 ms; range 1000..65535)
# (dot11FTReassociationDeadline)
#reassociation_deadline=1000

# List of R0KHs in the same Mobility Domain
# format: <MAC address> <NAS Identifier> <128-bit key as hex string>
# This list is used to map R0KH-ID (NAS Identifier) to a destination MAC
# address when requesting PMK-R1 key from the R0KH that the STA used during the
# Initial Mobility Domain Association.
#r0kh=02:01:02:03:04:05 r0kh-1.example.com 000102030405060708090a0b0c0d0e0f
#r0kh=02:01:02:03:04:06 r0kh-2.example.com 00112233445566778899aabbccddeeff
# And so on.. One line per R0KH.

# List of R1KHs in the same Mobility Domain
# format: <MAC address> <R0KH-ID> <128-bit key as hex string>
# This list is used to map R1KH-ID to a destination MAC address when sending
# PMK-R1 key from the R0KH. This is also the list of authorized R1KHs in the MD
# that can request PMK-R1 keys.
#r1kh=02:01:02:03:04:05 02:11:22:33:44:55 000102030405060708090a0b0c0d0e0f
#r1kh=02:01:02:03:04:06 02:11:22:33:44:66 00112233445566778899aabbccddeeff
# And so on.. One line per R1KH.

# Whether PMK-R1 push is enabled at R0KH
# 0 = do not push PMK-R1 to all configured R1KHs (default)
# 1 = push PMK-R1 to all configured R1KHs whenever a new PMK-R0 is derived
#pmk_r1_push=1

##### Passive scanning ########################################################
# Scan different channels every N seconds. 0 = disable passive scanning.
#passive_scan_interval=60

# Listen N usecs on each channel when doing passive scanning.
# This value plus the time needed for changing channels should be less than
# 32 milliseconds (i.e. 32000 usec) to avoid interruptions to normal
# operations. Time needed for channel changing varies based on the used wlan
# hardware.
# default: disabled (0)
#passive_scan_listen=10000

# Passive scanning mode:
# 0 = scan all supported modes (802.11a/b/g/Turbo) (default)
# 1 = scan only the mode that is currently used for normal operations
#passive_scan_mode=1

# Maximum number of entries kept in AP table (either for passive scanning or
# for detecting Overlapping Legacy BSS Condition). The oldest entry will be
# removed when adding a new entry that would make the list grow over this
# limit. Note! Wi-Fi certification for IEEE 802.11g requires that OLBC is
# enabled, so this field should not be set to 0 when using IEEE 802.11g.
# default: 255
#ap_table_max_size=255

# Number of seconds of no frames received after which entries may be deleted
# from the AP table. Since passive scanning is not usually performed frequently
# this should not be set to very small value. In addition, there is no
# guarantee that every scan cycle will receive beacon frames from the
# neighboring APs.
# default: 60
#ap_table_expiration_time=3600


##### Wi-Fi Protected Setup (WPS) #############################################

# WPS state
# 0 = WPS disabled (default)
# 1 = WPS enabled, not configured
# 2 = WPS enabled, configured
#wps_state=2

# AP can be configured into a locked state where new WPS Registrar are not
# accepted, but previously authorized Registrars (including the internal one)
# can continue to add new Enrollees.
#ap_setup_locked=1

# Universally Unique IDentifier (UUID; see RFC 4122) of the device
# This value is used as the UUID for the internal WPS Registrar. If the AP
# is also using UPnP, this value should be set to the device's UPnP UUID.
# If not configured, UUID will be generated based on the local MAC address.
#uuid=12345678-9abc-def0-1234-56789abcdef0

# Note: If wpa_psk_file is set, WPS is used to generate random, per-device PSKs
# that will be appended to the wpa_psk_file. If wpa_psk_file is not set, the
# default PSK (wpa_psk/wpa_passphrase) will be delivered to Enrollees. Use of
# per-device PSKs is recommended as the more secure option (i.e., make sure to
# set wpa_psk_file when using WPS with WPA-PSK).

# When an Enrollee requests access to the network with PIN method, the Enrollee
# PIN will need to be entered for the Registrar. PIN request notifications are
# sent to hostapd ctrl_iface monitor. In addition, they can be written to a
# text file that could be used, e.g., to populate the AP administration UI with
# pending PIN requests. If the following variable is set, the PIN requests will
# be written to the configured file.
#wps_pin_requests=/var/run/hostapd_wps_pin_requests

# Device Name
# User-friendly description of device; up to 32 octets encoded in UTF-8
#device_name=Wireless AP

# Manufacturer
# The manufacturer of the device (up to 64 ASCII characters)
#manufacturer=Company

# Model Name
# Model of the device (up to 32 ASCII characters)
#model_name=WAP

# Model Number
# Additional device description (up to 32 ASCII characters)
#model_number=123

# Serial Number
# Serial number of the device (up to 32 characters)
#serial_number=12345

# Primary Device Type
# Used format: <categ>-<OUI>-<subcateg>
# categ = Category as an integer value
# OUI = OUI and type octet as a 4-octet hex-encoded value; 0050F204 for
#       default WPS OUI
# subcateg = OUI-specific Sub Category as an integer value
# Examples:
#   1-0050F204-1 (Computer / PC)
#   1-0050F204-2 (Computer / Server)
#   5-0050F204-1 (Storage / NAS)
#   6-0050F204-1 (Network Infrastructure / AP)
#device_type=6-0050F204-1

# OS Version
# 4-octet operating system version number (hex string)
#os_version=01020300

# Config Methods
# List of the supported configuration methods
#config_methods=label display push_button keypad

# Access point PIN for initial configuration and adding Registrars
# If not set, hostapd will not allow external WPS Registrars to control the
# access point.
#ap_pin=12345670

# Skip building of automatic WPS credential
# This can be used to allow the automatically generated Credential attribute to
# be replaced with pre-configured Credential(s).
#skip_cred_build=1

# Additional Credential attribute(s)
# This option can be used to add pre-configured Credential attributes into M8
# message when acting as a Registrar. If skip_cred_build=1, this data will also
# be able to override the Credential attribute that would have otherwise been
# automatically generated based on network configuration. This configuration
# option points to an external file that much contain the WPS Credential
# attribute(s) as binary data.
#extra_cred=hostapd.cred

# Credential processing
#   0 = process received credentials internally (default)
#   1 = do not process received credentials; just pass them over ctrl_iface to
#	external program(s)
#   2 = process received credentials internally and pass them over ctrl_iface
#	to external program(s)
# Note: With wps_cred_processing=1, skip_cred_build should be set to 1 and
# extra_cred be used to provide the Credential data for Enrollees.
#
# wps_cred_processing=1 will disabled automatic updates of hostapd.conf file
# both for Credential processing and for marking AP Setup Locked based on
# validation failures of AP PIN. An external program is responsible on updating
# the configuration appropriately in this case.
#wps_cred_processing=0

# AP Settings Attributes for M7
# By default, hostapd generates the AP Settings Attributes for M7 based on the
# current configuration. It is possible to override this by providing a file
# with pre-configured attributes. This is similar to extra_cred file format,
# but the AP Settings attributes are not encapsulated in a Credential
# attribute.
#ap_settings=hostapd.ap_settings

# WPS UPnP interface
# If set, support for external Registrars is enabled.
#upnp_iface=br0

# Friendly Name (required for UPnP)
# Short description for end use. Should be less than 64 characters.
#friendly_name=WPS Access Point

# Manufacturer URL (optional for UPnP)
#manufacturer_url=http://www.example.com/

# Model Description (recommended for UPnP)
# Long description for end user. Should be less than 128 characters.
#model_description=Wireless Access Point

# Model URL (optional for UPnP)
#model_url=http://www.example.com/model/

# Universal Product Code (optional for UPnP)
# 12-digit, all-numeric code that identifies the consumer package.
#upc=123456789012

END
;

if (($wlanapsettings{'ENC'} eq 'wep') || ($wlanapsettings{'ENC'} eq 'wep+wpa')) {
    print CONFIGFILE <<END

# Static WEP key configuration
#
# The key number to use when transmitting.
# It must be between 0 and 3, and the corresponding key must be set.
# default: not set
wep_default_key=0
# The WEP keys to use.
# A key may be a quoted string or unquoted hexadecimal digits.
# The key length should be 5, 13, or 16 characters, or 10, 26, or 32
# digits, depending on whether 40-bit (64-bit), 104-bit (128-bit), or
# 128-bit (152-bit) WEP is used.
# Only the default key must be supplied; the others are optional.
# default: not set
wep_key0=$wlanapsettings{$key}

END
;
    }

  close CONFIGFILE;
}
